diff -upr ioquake3svn1438/code/q3_ui/ui_servers2.c ioquake3serverFix/code/q3_ui/ui_servers2.c
--- ioquake3svn1438/code/q3_ui/ui_servers2.c	2008-07-07 15:32:57.000000000 -0500
+++ ioquake3serverFix/code/q3_ui/ui_servers2.c	2008-08-09 11:28:12.000000000 -0500
@@ -32,16 +32,16 @@ MULTIPLAYER MENU (SERVER BROWSER)
 #include "ui_local.h"
 
 
-#define MAX_GLOBALSERVERS		256
+#define MAX_GLOBALSERVERS		128
 #define MAX_PINGREQUESTS		32
 #define MAX_ADDRESSLENGTH		64
-#define MAX_HOSTNAMELENGTH		31
-#define MAX_MAPNAMELENGTH		20
-#define MAX_LISTBOXITEMS		256
-#define MAX_LOCALSERVERS		124
+#define MAX_HOSTNAMELENGTH		22
+#define MAX_MAPNAMELENGTH		16
+#define MAX_LISTBOXITEMS		128
+#define MAX_LOCALSERVERS		128
 #define MAX_STATUSLENGTH		64
 #define MAX_LEAGUELENGTH		28
-#define MAX_LISTBOXWIDTH		70
+#define MAX_LISTBOXWIDTH		68
 
 #define ART_BACK0				"menu/art/back_0"
 #define ART_BACK1				"menu/art/back_1"
@@ -59,14 +59,13 @@ MULTIPLAYER MENU (SERVER BROWSER)
 #define ART_UNKNOWNMAP			"menu/art/unknownmap"
 #define ART_REMOVE0				"menu/art/delete_0"
 #define ART_REMOVE1				"menu/art/delete_1"
-//#define ART_PUNKBUSTER		"menu/art/pblogo"
+#define ART_PUNKBUSTER		"menu/art/pblogo"
 
 #define ID_MASTER			10
 #define ID_GAMETYPE			11
 #define ID_SORTKEY			12
 #define ID_SHOW_FULL		13
 #define ID_SHOW_EMPTY		14
-
 #define ID_LIST				15
 #define ID_SCROLL_UP		16
 #define ID_SCROLL_DOWN		17
@@ -76,19 +75,18 @@ MULTIPLAYER MENU (SERVER BROWSER)
 #define ID_CREATE			21
 #define ID_CONNECT			22
 #define ID_REMOVE			23
-
-//Beta 23
-#define ID_ONLY_HUMANS          24
-#define ID_HIDE_PRIVATE         25
-//#define ID_PUNKBUSTER 24
+#define ID_PUNKBUSTER 24
 
 #define GR_LOGO				30
 #define GR_LETTERS			31
 
-#define AS_LOCAL			0
-#define AS_MPLAYER			1
-#define AS_GLOBAL			2
-#define AS_FAVORITES		3
+#define UIAS_LOCAL			0
+#define UIAS_GLOBAL1			1
+#define UIAS_GLOBAL2			2
+#define UIAS_GLOBAL3			3
+#define UIAS_GLOBAL4			4
+#define UIAS_GLOBAL5			5
+#define UIAS_FAVORITES			6
 
 #define SORT_HOST			0
 #define SORT_MAP			1
@@ -101,15 +99,14 @@ MULTIPLAYER MENU (SERVER BROWSER)
 #define GAMES_TEAMPLAY		2
 #define GAMES_TOURNEY		3
 #define GAMES_CTF			4
-#define GAMES_ELIMINATION		5
-#define GAMES_CTF_ELIMINATION		6
-#define GAMES_LMS			7
-#define GAMES_DOUBLE_D			8
-
 
 static const char *master_items[] = {
 	"Local",
-	"Internet",
+	"Internet1",
+	"Internet2",
+	"Internet3",
+	"Internet4",
+	"Internet5",
 	"Favorites",
 	NULL
 };
@@ -120,10 +117,6 @@ static const char *servertype_items[] = 
 	"Team Deathmatch",
 	"Tournament",
 	"Capture the Flag",
-	"Elimination",
-	"CTF Elimination",
-	"Last Man Standing",
-	"Double Domination",
 	NULL
 };
 
@@ -145,11 +138,7 @@ static char* gamenames[] = {
 	"One Flag CTF",		// one flag ctf
 	"OverLoad",				// Overload
 	"Harvester",			// Harvester
-	"Elimination",
-	"CTF Elimination",
-	"Last Man Standing",
-	"Double Domination",
-        "Rocket Arena 3",	// Rocket Arena 3
+	"Rocket Arena 3",	// Rocket Arena 3
 	"Q3F",						// Q3F
 	"Urban Terror",		// Urban Terror
 	"OSP",						// Orange Smoothie Productions
@@ -159,14 +148,14 @@ static char* gamenames[] = {
 
 static char* netnames[] = {
 	"???",
-	"IP4",
-        "IP6",
+	"UDP",
+	"UDP6",
 	NULL
 };
 
-static char quake3worldMessage[] = "Visit www.openarena.ws - News, Community, Events, Files";
+static char quake3worldMessage[] = "Visit www.quake3world.com - News, Community, Events, Files";
 
-/*const char* punkbuster_items[] = {
+const char* punkbuster_items[] = {
 	"Disabled",
 	"Enabled",
 	NULL
@@ -178,7 +167,7 @@ const char* punkbuster_msg[] = {
 	"Quake III Arena",
 	"is started.",
 	NULL
-};*/
+};
 
 typedef struct {
 	char	adrstr[MAX_ADDRESSLENGTH];
@@ -190,21 +179,19 @@ typedef struct servernode_s {
 	char	hostname[MAX_HOSTNAMELENGTH+3];
 	char	mapname[MAX_MAPNAMELENGTH];
 	int		numclients;
-        int             humanclients;
-        qboolean        needPass;
 	int		maxclients;
 	int		pingtime;
 	int		gametype;
-	char	gamename[16];
+	char	gamename[12];
 	int		nettype;
 	int		minPing;
 	int		maxPing;
-	//qboolean bPB;
+	qboolean bPB;
 
 } servernode_t; 
 
 typedef struct {
-	char			buff[MAX_LISTBOXWIDTH+62]; //	+60 gives room for color codes... Sago: I need two more
+	char			buff[MAX_LISTBOXWIDTH];
 	servernode_t*	servernode;
 } table_t;
 
@@ -218,9 +205,6 @@ typedef struct {
 	menulist_s			sortkey;
 	menuradiobutton_s	showfull;
 	menuradiobutton_s	showempty;
-        
-        menuradiobutton_s	onlyhumans;
-        menuradiobutton_s	hideprivate;
 
 	menulist_s			list;
 	menubitmap_s		mappic;
@@ -251,8 +235,8 @@ typedef struct {
 	char				favoriteaddresses[MAX_FAVORITESERVERS][MAX_ADDRESSLENGTH];
 	int					numfavoriteaddresses;
 
-	//menulist_s		punkbuster;
-	//menubitmap_s	pblogo;
+	menulist_s		punkbuster;
+	menubitmap_s	pblogo;
 } arenaservers_t;
 
 static arenaservers_t	g_arenaservers;
@@ -264,16 +248,12 @@ static servernode_t		g_localserverlist[M
 static int				g_numlocalservers;
 static servernode_t		g_favoriteserverlist[MAX_FAVORITESERVERS];
 static int				g_numfavoriteservers;
-static servernode_t		g_mplayerserverlist[MAX_GLOBALSERVERS];
-static int				g_nummplayerservers;
 static int				g_servertype;
 static int				g_gametype;
 static int				g_sortkey;
 static int				g_emptyservers;
 static int				g_fullservers;
 
-static int				g_onlyhumans;
-static int                              g_hideprivate;
 
 /*
 =================
@@ -392,57 +372,6 @@ static void ArenaServers_UpdatePicture( 
 	g_arenaservers.mappic.shader = 0;
 }
 
-/*
-=================
-	Q_strcpyColor - This function will return the real length of the string if numChars
-		len of character data is desired. It looks for color codes and adds 2 to the length
-		for each combo found. This is used to make color strings show up correctly in column
-		formatted environments. Otherwise, the columns will be off 2 * num of color codes.
-=================
-*/
-int Q_strcpyColor( const char *src, char *dest, int numChars )
-{
-int count, len;
-char *d;
-const char *s;
-
-	if( !src || !dest )
-	{
-		return 0;
-	}
-
-	count = len = 0;
-	s = src;
-	d = dest;
-
-	while( *s && count < numChars )
-	{
-		if( Q_IsColorString( s ))
-		{
-			*d++ = *s++;
-			*d++ = *s++;
-			len += 2;
-			continue;
-		}
-		*d = *s;
-		s++;
-		d++;
-		count++;
-		len++;
-	}
-
-	// Now fill up the end of the string with space characters if needed...
-	while( count < numChars )
-	{
-		*d = ' ';
-                //d[len] = ' ';
-		d++;
-		len++;
-		count++;
-	}
-	return len;
-}
-
 
 /*
 =================
@@ -452,11 +381,11 @@ ArenaServers_UpdateMenu
 static void ArenaServers_UpdateMenu( void ) {
 	int				i;
 	int				j;
-	int				count, bufAddr;
+	int				count;
 	char*			buff;
 	servernode_t*	servernodeptr;
 	table_t*		tableptr;
-	char			*b, *pingColor;
+	char			*pingColor;
 
 	if( g_arenaservers.numqueriedservers > 0 ) {
 		// servers found
@@ -472,16 +401,14 @@ static void ArenaServers_UpdateMenu( voi
 			g_arenaservers.gametype.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.sortkey.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.showempty.generic.flags	&= ~QMF_GRAYED;
-                        g_arenaservers.onlyhumans.generic.flags	&= ~QMF_GRAYED;
-                        g_arenaservers.hideprivate.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.showfull.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.list.generic.flags		&= ~QMF_GRAYED;
 			g_arenaservers.refresh.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.go.generic.flags			&= ~QMF_GRAYED;
-			//g_arenaservers.punkbuster.generic.flags &= ~QMF_GRAYED;
+			g_arenaservers.punkbuster.generic.flags &= ~QMF_GRAYED;
 
 			// update status bar
-			if( g_servertype == AS_GLOBAL || g_servertype == AS_MPLAYER ) {
+			if( g_servertype >= UIAS_GLOBAL1 && g_servertype <= UIAS_GLOBAL5 ) {
 				g_arenaservers.statusbar.string = quake3worldMessage;
 			}
 			else {
@@ -501,13 +428,11 @@ static void ArenaServers_UpdateMenu( voi
 			g_arenaservers.gametype.generic.flags	|= QMF_GRAYED;
 			g_arenaservers.sortkey.generic.flags	|= QMF_GRAYED;
 			g_arenaservers.showempty.generic.flags	|= QMF_GRAYED;
-                        g_arenaservers.onlyhumans.generic.flags	|= QMF_GRAYED;
-                        g_arenaservers.hideprivate.generic.flags	|= QMF_GRAYED;
 			g_arenaservers.showfull.generic.flags	|= QMF_GRAYED;
 			g_arenaservers.list.generic.flags		|= QMF_GRAYED;
 			g_arenaservers.refresh.generic.flags	|= QMF_GRAYED;
 			g_arenaservers.go.generic.flags			|= QMF_GRAYED;
-			//g_arenaservers.punkbuster.generic.flags |= QMF_GRAYED;
+			g_arenaservers.punkbuster.generic.flags |= QMF_GRAYED;
 		}
 		else {
 			if( g_arenaservers.numqueriedservers < 0 ) {
@@ -518,7 +443,7 @@ static void ArenaServers_UpdateMenu( voi
 			}
 
 			// update status bar
-			if( g_servertype == AS_GLOBAL || g_servertype == AS_MPLAYER ) {
+			if( g_servertype >= UIAS_GLOBAL1 && g_servertype <= UIAS_GLOBAL5 ) {
 				g_arenaservers.statusbar.string = quake3worldMessage;
 			}
 			else {
@@ -530,13 +455,11 @@ static void ArenaServers_UpdateMenu( voi
 			g_arenaservers.gametype.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.sortkey.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.showempty.generic.flags	&= ~QMF_GRAYED;
-                        g_arenaservers.onlyhumans.generic.flags	&= ~QMF_GRAYED;
-                        g_arenaservers.hideprivate.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.showfull.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.list.generic.flags		|= QMF_GRAYED;
 			g_arenaservers.refresh.generic.flags	&= ~QMF_GRAYED;
 			g_arenaservers.go.generic.flags			|= QMF_GRAYED;
-			//g_arenaservers.punkbuster.generic.flags &= ~QMF_GRAYED;
+			g_arenaservers.punkbuster.generic.flags &= ~QMF_GRAYED;
 		}
 
 		// zero out list box
@@ -593,34 +516,7 @@ static void ArenaServers_UpdateMenu( voi
 				continue;
 			}
 			break;
-
-		case GAMES_ELIMINATION:
-			if( servernodeptr->gametype != GT_ELIMINATION ) {
-				continue;
-			}
-			break;
-		
-		case GAMES_CTF_ELIMINATION:
-			if( servernodeptr->gametype != GT_CTF_ELIMINATION ) {
-				continue;
-			}
-			break;
-
-		case GAMES_LMS:
-			if( servernodeptr->gametype != GT_LMS ) {
-				continue;
-			}
-			break;
-
-		case GAMES_DOUBLE_D:
-			if( servernodeptr->gametype != GT_DOUBLE_D ) {
-				continue;
-			}
-			break;
 		}
-                
-                if(g_hideprivate && servernodeptr->needPass)
-                    continue;
 
 		if( servernodeptr->pingtime < servernodeptr->minPing ) {
 			pingColor = S_COLOR_BLUE;
@@ -638,45 +534,17 @@ static void ArenaServers_UpdateMenu( voi
 			pingColor = S_COLOR_RED;
 		}
 
-                /*
-		Com_sprintf( buff, MAX_LISTBOXWIDTH, "%-20.20s %-12.12s %2d/%2d %-8.8s %3s %s%3d ", 
+		Com_sprintf( buff, MAX_LISTBOXWIDTH, "%-20.20s %-12.12s %2d/%2d %-8.8s %3s %s%3d " S_COLOR_YELLOW "%s", 
 			servernodeptr->hostname, servernodeptr->mapname, servernodeptr->numclients,
  			servernodeptr->maxclients, servernodeptr->gamename,
-			netnames[servernodeptr->nettype], pingColor, servernodeptr->pingtime ); //, servernodeptr->bPB ? "Yes" : "No"
-                 */
-                b = buff;
-		bufAddr = Q_strcpyColor( servernodeptr->hostname, b, 30 );
-		b += bufAddr; 
-		*b++ = ' ';
-                //*b++ = '^';
-                //*b++ = '7';
-	
-		bufAddr = Q_strcpyColor( servernodeptr->mapname, b, 16 );
-		b += bufAddr;
-		*b++ = ' ';
-	
-                if(g_onlyhumans == 0)
-                    Com_sprintf( b, 7, "%2d/%2d ", servernodeptr->numclients, servernodeptr->maxclients );
-                else
-                    Com_sprintf( b, 7, "%2d/%2d ", servernodeptr->humanclients, servernodeptr->maxclients );
-		b += 6;
-	
-		bufAddr = Q_strcpyColor( servernodeptr->gamename, b, 8 );
-		b += bufAddr;
-		*b++ = ' ';
-                
-                bufAddr = Q_strcpyColor( netnames[servernodeptr->nettype], b, 3 );
-                b += bufAddr;
-                *b++ = ' ';
-                
-		Com_sprintf( b, 12, "%s%3d ", 	pingColor, servernodeptr->pingtime );
+			netnames[servernodeptr->nettype], pingColor, servernodeptr->pingtime, servernodeptr->bPB ? "Yes" : "No" );
 		j++;
 	}
 
 	g_arenaservers.list.numitems = j;
 	g_arenaservers.list.curvalue = 0;
 	g_arenaservers.list.top      = 0;
-        
+
 	// update picture
 	ArenaServers_UpdatePicture();
 }
@@ -703,21 +571,21 @@ static void ArenaServers_Remove( void )
 	tableptr      = &g_arenaservers.table[g_arenaservers.list.curvalue];
 	servernodeptr = tableptr->servernode;
 
-        // find address in master list
+	// find address in master list
 	for (i=0; i<g_arenaservers.numfavoriteaddresses; i++)
 	{
 		if (!Q_stricmp(g_arenaservers.favoriteaddresses[i],servernodeptr->adrstr))
 		{
 			// delete address from master list
- 			if (i < g_arenaservers.numfavoriteaddresses-1)
- 			{
- 				// shift items up
- 				memcpy( &g_arenaservers.favoriteaddresses[i], &g_arenaservers.favoriteaddresses[i+1], (g_arenaservers.numfavoriteaddresses - i - 1)* MAX_ADDRESSLENGTH );
+			if (i < g_arenaservers.numfavoriteaddresses-1)
+			{
+				// shift items up
+				memcpy( &g_arenaservers.favoriteaddresses[i], &g_arenaservers.favoriteaddresses[i+1], (g_arenaservers.numfavoriteaddresses - i - 1)* MAX_ADDRESSLENGTH );
 			}
- 			g_arenaservers.numfavoriteaddresses--;
- 			memset( &g_arenaservers.favoriteaddresses[g_arenaservers.numfavoriteaddresses], 0, MAX_ADDRESSLENGTH );
- 			break;
-                }
+			g_arenaservers.numfavoriteaddresses--;
+			memset( &g_arenaservers.favoriteaddresses[g_arenaservers.numfavoriteaddresses], 0, MAX_ADDRESSLENGTH );
+			break;
+		}
 	}	
 
 	// find address in server list
@@ -725,16 +593,17 @@ static void ArenaServers_Remove( void )
 	{
 		if (&g_favoriteserverlist[i] == servernodeptr)
 		{
+
 			// delete address from server list
- 			if (i < g_numfavoriteservers-1)
- 			{
- 				// shift items up
- 				memcpy( &g_favoriteserverlist[i], &g_favoriteserverlist[i+1], (g_numfavoriteservers - i - 1)*sizeof(servernode_t));
- 			}
- 			g_numfavoriteservers--;
- 			memset( &g_favoriteserverlist[ g_numfavoriteservers ], 0, sizeof(servernode_t));
- 			break;
-                }
+			if (i < g_numfavoriteservers-1)
+			{
+				// shift items up
+				memcpy( &g_favoriteserverlist[i], &g_favoriteserverlist[i+1], (g_numfavoriteservers - i - 1)*sizeof(servernode_t));
+			}
+			g_numfavoriteservers--;
+			memset( &g_favoriteserverlist[ g_numfavoriteservers ], 0, sizeof(servernode_t));
+			break;
+		}
 	}	
 
 	g_arenaservers.numqueriedservers = g_arenaservers.numfavoriteaddresses;
@@ -754,7 +623,7 @@ static void ArenaServers_Insert( char* a
 	int				i;
 
 
-	if ((pingtime >= ArenaServers_MaxPing()) && (g_servertype != AS_FAVORITES))
+	if ((pingtime >= ArenaServers_MaxPing()) && (g_servertype != UIAS_FAVORITES))
 	{
 		// slow global or local servers do not get entered
 		return;
@@ -780,15 +649,13 @@ static void ArenaServers_Insert( char* a
 	Q_strupr( servernodeptr->mapname );
 
 	servernodeptr->numclients = atoi( Info_ValueForKey( info, "clients") );
-        servernodeptr->humanclients = atoi( Info_ValueForKey( info, "g_humanplayers") );
-        servernodeptr->needPass = atoi( Info_ValueForKey( info, "g_needpass") );
 	servernodeptr->maxclients = atoi( Info_ValueForKey( info, "sv_maxclients") );
 	servernodeptr->pingtime   = pingtime;
 	servernodeptr->minPing    = atoi( Info_ValueForKey( info, "minPing") );
 	servernodeptr->maxPing    = atoi( Info_ValueForKey( info, "maxPing") );
-	//servernodeptr->bPB = atoi( Info_ValueForKey( info, "punkbuster") );
+	servernodeptr->bPB = atoi( Info_ValueForKey( info, "punkbuster") );
 
-	
+	/*
 	s = Info_ValueForKey( info, "nettype" );
 	for (i=0; ;i++)
 	{
@@ -803,7 +670,7 @@ static void ArenaServers_Insert( char* a
 			break;
 		}
 	}
-	
+	*/
 	servernodeptr->nettype = atoi(Info_ValueForKey(info, "nettype"));
 
 	s = Info_ValueForKey( info, "game");
@@ -947,7 +814,7 @@ static void ArenaServers_StopRefresh( vo
 
 	g_arenaservers.refreshservers = qfalse;
 
-	if (g_servertype == AS_FAVORITES)
+	if (g_servertype == UIAS_FAVORITES)
 	{
 		// nonresponsive favorites must be shown
 		ArenaServers_InsertFavorites();
@@ -983,8 +850,8 @@ static void ArenaServers_DoRefresh( void
 
 	if (uis.realtime < g_arenaservers.refreshtime)
 	{
-	  if (g_servertype != AS_FAVORITES) {
-			if (g_servertype == AS_LOCAL) {
+	  if (g_servertype != UIAS_FAVORITES) {
+			if (g_servertype == UIAS_LOCAL) {
 				if (!trap_LAN_GetServerCount(g_servertype)) {
 					return;
 				}
@@ -1058,7 +925,7 @@ static void ArenaServers_DoRefresh( void
 
 	// get results of servers query
 	// counts can increase as servers respond
-	if (g_servertype == AS_FAVORITES) {
+	if (g_servertype == UIAS_FAVORITES) {
 	  g_arenaservers.numqueriedservers = g_arenaservers.numfavoriteaddresses;
 	} else {
 	  g_arenaservers.numqueriedservers = trap_LAN_GetServerCount(g_servertype);
@@ -1088,7 +955,7 @@ static void ArenaServers_DoRefresh( void
 
 		// get an address to ping
 
-		if (g_servertype == AS_FAVORITES) {
+		if (g_servertype == UIAS_FAVORITES) {
 		  strcpy( adrstr, g_arenaservers.favoriteaddresses[g_arenaservers.currentping] ); 		
 		} else {
 		  trap_LAN_GetServerAddressString(g_servertype, g_arenaservers.currentping, adrstr, MAX_ADDRESSLENGTH );
@@ -1145,19 +1012,12 @@ static void ArenaServers_StartRefresh( v
 	// place menu in zeroed state
 	ArenaServers_UpdateMenu();
 
-	if( g_servertype == AS_LOCAL ) {
+	if( g_servertype == UIAS_LOCAL ) {
 		trap_Cmd_ExecuteText( EXEC_APPEND, "localservers\n" );
 		return;
 	}
 
-	if( g_servertype == AS_GLOBAL || g_servertype == AS_MPLAYER ) {
-		if( g_servertype == AS_GLOBAL ) {
-			i = 0;
-		}
-		else {
-			i = 1;
-		}
-
+	if( g_servertype >= UIAS_GLOBAL1 && g_servertype <= UIAS_GLOBAL5 ) {
 		switch( g_arenaservers.gametype.curvalue ) {
 		default:
 		case GAMES_ALL:
@@ -1179,22 +1039,6 @@ static void ArenaServers_StartRefresh( v
 		case GAMES_CTF:
 			strcpy( myargs, " ctf" );
 			break;
-
-		case GAMES_ELIMINATION:
-			strcpy( myargs, " elimination" );
-			break;
-
-		case GAMES_CTF_ELIMINATION:
-			strcpy( myargs, " ctfelimination" );
-			break;
-
-		case GAMES_LMS:
-			strcpy( myargs, " lms" );
-			break;
-		
-		case GAMES_DOUBLE_D:
-			strcpy( myargs, " dd" );
-			break;
 		}
 
 
@@ -1209,10 +1053,10 @@ static void ArenaServers_StartRefresh( v
 		protocol[0] = '\0';
 		trap_Cvar_VariableStringBuffer( "debug_protocol", protocol, sizeof(protocol) );
 		if (strlen(protocol)) {
-			trap_Cmd_ExecuteText( EXEC_APPEND, va( "globalservers %d %s%s\n", i, protocol, myargs ));
+			trap_Cmd_ExecuteText( EXEC_APPEND, va( "globalservers %d %s%s\n", g_servertype - 1, protocol, myargs ));
 		}
 		else {
-			trap_Cmd_ExecuteText( EXEC_APPEND, va( "globalservers %d %d%s\n", i, (int)trap_Cvar_VariableValue( "protocol" ), myargs ) );
+			trap_Cmd_ExecuteText( EXEC_APPEND, va( "globalservers %d %d%s\n", g_servertype - 1, (int)trap_Cvar_VariableValue( "protocol" ), myargs ) );
 		}
 	}
 }
@@ -1255,43 +1099,52 @@ void ArenaServers_Sort( int type ) {
 ArenaServers_SetType
 =================
 */
-void ArenaServers_SetType( int type )
+int ArenaServers_SetType( int type )
 {
-	if (g_servertype == type)
-		return;
+	if(type >= UIAS_GLOBAL1 && type <= UIAS_GLOBAL5)
+	{
+		char masterstr[2], cvarname[sizeof("sv_master1")];
+		
+		while(type <= UIAS_GLOBAL5)
+		{
+			Com_sprintf(cvarname, sizeof(cvarname), "sv_master%d", type);
+			trap_Cvar_VariableStringBuffer(cvarname, masterstr, sizeof(masterstr));
+			if(*masterstr)
+				break;
+			
+			type++;
+		}
+	}
 
 	g_servertype = type;
 
 	switch( type ) {
 	default:
-	case AS_LOCAL:
+	case UIAS_LOCAL:
 		g_arenaservers.remove.generic.flags |= (QMF_INACTIVE|QMF_HIDDEN);
 		g_arenaservers.serverlist = g_localserverlist;
 		g_arenaservers.numservers = &g_numlocalservers;
 		g_arenaservers.maxservers = MAX_LOCALSERVERS;
 		break;
 
-	case AS_GLOBAL:
+	case UIAS_GLOBAL1:
+	case UIAS_GLOBAL2:
+	case UIAS_GLOBAL3:
+	case UIAS_GLOBAL4:
+	case UIAS_GLOBAL5:
 		g_arenaservers.remove.generic.flags |= (QMF_INACTIVE|QMF_HIDDEN);
 		g_arenaservers.serverlist = g_globalserverlist;
 		g_arenaservers.numservers = &g_numglobalservers;
 		g_arenaservers.maxservers = MAX_GLOBALSERVERS;
 		break;
 
-	case AS_FAVORITES:
+	case UIAS_FAVORITES:
 		g_arenaservers.remove.generic.flags &= ~(QMF_INACTIVE|QMF_HIDDEN);
 		g_arenaservers.serverlist = g_favoriteserverlist;
 		g_arenaservers.numservers = &g_numfavoriteservers;
 		g_arenaservers.maxservers = MAX_FAVORITESERVERS;
 		break;
 
-	case AS_MPLAYER:
-		g_arenaservers.remove.generic.flags |= (QMF_INACTIVE|QMF_HIDDEN);
-		g_arenaservers.serverlist = g_mplayerserverlist;
-		g_arenaservers.numservers = &g_nummplayerservers;
-		g_arenaservers.maxservers = MAX_GLOBALSERVERS;
-		break;
-		
 	}
 
 	if( !*g_arenaservers.numservers ) {
@@ -1304,6 +1157,8 @@ void ArenaServers_SetType( int type )
 		ArenaServers_UpdateMenu();
 	}
 	strcpy(g_arenaservers.status.string,"hit refresh to update");
+	
+	return type;
 }
 
 /*
@@ -1311,7 +1166,7 @@ void ArenaServers_SetType( int type )
 PunkBuster_Confirm
 =================
 */
-/*static void Punkbuster_ConfirmEnable( qboolean result ) {
+static void Punkbuster_ConfirmEnable( qboolean result ) {
 	if (result)
 	{		
 		trap_SetPbClStatus(1);
@@ -1326,7 +1181,7 @@ static void Punkbuster_ConfirmDisable( q
 		UI_Message( punkbuster_msg );
 	}
 	g_arenaservers.punkbuster.curvalue = Com_Clamp( 0, 1, trap_Cvar_VariableValue( "cl_punkbuster" ) );
-}*/
+}
 
 /*
 =================
@@ -1335,7 +1190,6 @@ ArenaServers_Event
 */
 static void ArenaServers_Event( void* ptr, int event ) {
 	int		id;
-	int value;
 
 	id = ((menucommon_s*)ptr)->id;
 
@@ -1345,13 +1199,8 @@ static void ArenaServers_Event( void* pt
 
 	switch( id ) {
 	case ID_MASTER:
-		value = g_arenaservers.master.curvalue;
-		if (value >= 1)
-		{
-			value++;
-		}
-		trap_Cvar_SetValue( "ui_browserMaster", value );
-		ArenaServers_SetType( value );
+		g_arenaservers.master.curvalue = ArenaServers_SetType(g_arenaservers.master.curvalue);
+		trap_Cvar_SetValue( "ui_browserMaster", g_arenaservers.master.curvalue);
 		break;
 
 	case ID_GAMETYPE:
@@ -1377,18 +1226,6 @@ static void ArenaServers_Event( void* pt
 		g_emptyservers = g_arenaservers.showempty.curvalue;
 		ArenaServers_UpdateMenu();
 		break;
-                
-        case ID_ONLY_HUMANS:
-		trap_Cvar_SetValue( "ui_browserOnlyHumans", g_arenaservers.onlyhumans.curvalue );
-                g_onlyhumans = g_arenaservers.onlyhumans.curvalue;
-		ArenaServers_UpdateMenu();
-		break;
-                
-        case ID_HIDE_PRIVATE:
-		//trap_Cvar_SetValue( "ui_browserHidePrivate", g_arenaservers.hideprivate.curvalue );
-                g_hideprivate = g_arenaservers.hideprivate.curvalue;
-		ArenaServers_UpdateMenu();
-		break;
 
 	case ID_LIST:
 		if( event == QM_GOTFOCUS ) {
@@ -1431,7 +1268,7 @@ static void ArenaServers_Event( void* pt
 		ArenaServers_UpdateMenu();
 		break;
 	
-	/*case ID_PUNKBUSTER:
+	case ID_PUNKBUSTER:
 		if (g_arenaservers.punkbuster.curvalue)			
 		{
 			UI_ConfirmMenu_Style( "Enable Punkbuster?",  UI_CENTER|UI_INVERSE|UI_SMALLFONT, 0, Punkbuster_ConfirmEnable );
@@ -1440,7 +1277,7 @@ static void ArenaServers_Event( void* pt
 		{
 			UI_ConfirmMenu_Style( "Disable Punkbuster?", UI_CENTER|UI_INVERSE|UI_SMALLFONT, 0, Punkbuster_ConfirmDisable );
 		}
-		break;*/
+		break;
 	}
 }
 
@@ -1470,7 +1307,7 @@ static sfxHandle_t ArenaServers_MenuKey(
 		return menu_move_sound;
 	}
 
-	if( ( key == K_DEL || key == K_KP_DEL ) && ( g_servertype == AS_FAVORITES ) &&
+	if( ( key == K_DEL || key == K_KP_DEL ) && ( g_servertype == UIAS_FAVORITES ) &&
 		( Menu_ItemAtCursor( &g_arenaservers.menu) == &g_arenaservers.list ) ) {
 		ArenaServers_Remove();
 		ArenaServers_UpdateMenu();
@@ -1481,14 +1318,6 @@ static sfxHandle_t ArenaServers_MenuKey(
 		ArenaServers_StopRefresh();
 		ArenaServers_SaveChanges();
 	}
-        
-        if( key == K_MWHEELUP ) {
-            ScrollList_Key( &g_arenaservers.list, K_UPARROW );
-        }
-        
-        if( key == K_MWHEELDOWN ) {
-            ScrollList_Key( &g_arenaservers.list, K_DOWNARROW );
-        }
 
 
 	return Menu_DefaultKey( &g_arenaservers.menu, key );
@@ -1502,7 +1331,6 @@ ArenaServers_MenuInit
 */
 static void ArenaServers_MenuInit( void ) {
 	int			i;
-	int			type;
 	int			y;
 	int			value;
 	static char	statusbuffer[MAX_STATUSLENGTH];
@@ -1525,7 +1353,7 @@ static void ArenaServers_MenuInit( void 
 	g_arenaservers.banner.style  	    = UI_CENTER;
 	g_arenaservers.banner.color  	    = color_white;
 
-	y = 80-SMALLCHAR_HEIGHT;
+	y = 80;
 	g_arenaservers.master.generic.type			= MTYPE_SPINCONTROL;
 	g_arenaservers.master.generic.name			= "Servers:";
 	g_arenaservers.master.generic.flags			= QMF_PULSEIFFOCUS|QMF_SMALLFONT;
@@ -1572,31 +1400,13 @@ static void ArenaServers_MenuInit( void 
 	g_arenaservers.showempty.generic.id			= ID_SHOW_EMPTY;
 	g_arenaservers.showempty.generic.x			= 320;
 	g_arenaservers.showempty.generic.y			= y;
-        
-        y += SMALLCHAR_HEIGHT;
-	g_arenaservers.onlyhumans.generic.type		= MTYPE_RADIOBUTTON;
-	g_arenaservers.onlyhumans.generic.name		= "Only humans:";
-	g_arenaservers.onlyhumans.generic.flags		= QMF_PULSEIFFOCUS|QMF_SMALLFONT;
-	g_arenaservers.onlyhumans.generic.callback	= ArenaServers_Event;
-	g_arenaservers.onlyhumans.generic.id			= ID_ONLY_HUMANS;
-	g_arenaservers.onlyhumans.generic.x			= 320;
-	g_arenaservers.onlyhumans.generic.y			= y;
-        
-        y += SMALLCHAR_HEIGHT;
-	g_arenaservers.hideprivate.generic.type		= MTYPE_RADIOBUTTON;
-	g_arenaservers.hideprivate.generic.name		= "Hide private:";
-	g_arenaservers.hideprivate.generic.flags		= QMF_PULSEIFFOCUS|QMF_SMALLFONT;
-	g_arenaservers.hideprivate.generic.callback	= ArenaServers_Event;
-	g_arenaservers.hideprivate.generic.id			= ID_HIDE_PRIVATE;
-	g_arenaservers.hideprivate.generic.x			= 320;
-	g_arenaservers.hideprivate.generic.y			= y;
 
-	y += 2 * SMALLCHAR_HEIGHT;
+	y += 3 * SMALLCHAR_HEIGHT;
 	g_arenaservers.list.generic.type			= MTYPE_SCROLLLIST;
 	g_arenaservers.list.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
 	g_arenaservers.list.generic.id				= ID_LIST;
 	g_arenaservers.list.generic.callback		= ArenaServers_Event;
-	g_arenaservers.list.generic.x				= 22;
+	g_arenaservers.list.generic.x				= 72;
 	g_arenaservers.list.generic.y				= y;
 	g_arenaservers.list.width					= MAX_LISTBOXWIDTH;
 	g_arenaservers.list.height					= 11;
@@ -1617,8 +1427,8 @@ static void ArenaServers_MenuInit( void 
 	g_arenaservers.arrows.generic.name			= ART_ARROWS0;
 	g_arenaservers.arrows.generic.flags			= QMF_LEFT_JUSTIFY|QMF_INACTIVE;
 	g_arenaservers.arrows.generic.callback		= ArenaServers_Event;
-	g_arenaservers.arrows.generic.x				= 512+48+12;
-	g_arenaservers.arrows.generic.y				= 240-64+48;
+	g_arenaservers.arrows.generic.x				= 512+48;
+	g_arenaservers.arrows.generic.y				= 240-64+16;
 	g_arenaservers.arrows.width					= 64;
 	g_arenaservers.arrows.height				= 128;
 
@@ -1626,8 +1436,8 @@ static void ArenaServers_MenuInit( void 
 	g_arenaservers.up.generic.flags				= QMF_LEFT_JUSTIFY|QMF_PULSEIFFOCUS|QMF_MOUSEONLY;
 	g_arenaservers.up.generic.callback			= ArenaServers_Event;
 	g_arenaservers.up.generic.id				= ID_SCROLL_UP;
-	g_arenaservers.up.generic.x					= 512+48+12;
-	g_arenaservers.up.generic.y					= 240-64+48;
+	g_arenaservers.up.generic.x					= 512+48;
+	g_arenaservers.up.generic.y					= 240-64+16;
 	g_arenaservers.up.width						= 64;
 	g_arenaservers.up.height					= 64;
 	g_arenaservers.up.focuspic					= ART_ARROWS_UP;
@@ -1636,8 +1446,8 @@ static void ArenaServers_MenuInit( void 
 	g_arenaservers.down.generic.flags			= QMF_LEFT_JUSTIFY|QMF_PULSEIFFOCUS|QMF_MOUSEONLY;
 	g_arenaservers.down.generic.callback		= ArenaServers_Event;
 	g_arenaservers.down.generic.id				= ID_SCROLL_DOWN;
-	g_arenaservers.down.generic.x				= 512+48+12;
-	g_arenaservers.down.generic.y				= 240+48;
+	g_arenaservers.down.generic.x				= 512+48;
+	g_arenaservers.down.generic.y				= 240+16;
 	g_arenaservers.down.width					= 64;
 	g_arenaservers.down.height					= 64;
 	g_arenaservers.down.focuspic				= ART_ARROWS_DOWN;
@@ -1724,7 +1534,7 @@ static void ArenaServers_MenuInit( void 
 	g_arenaservers.go.height				= 64;
 	g_arenaservers.go.focuspic				= ART_CONNECT1;
 
-	/*g_arenaservers.punkbuster.generic.type			= MTYPE_SPINCONTROL;
+	g_arenaservers.punkbuster.generic.type			= MTYPE_SPINCONTROL;
 	g_arenaservers.punkbuster.generic.name			= "Punkbuster:";
 	g_arenaservers.punkbuster.generic.flags			= QMF_PULSEIFFOCUS|QMF_SMALLFONT;
 	g_arenaservers.punkbuster.generic.callback		= ArenaServers_Event;
@@ -1740,7 +1550,7 @@ static void ArenaServers_MenuInit( void 
 	g_arenaservers.pblogo.generic.y				= 176;
 	g_arenaservers.pblogo.width					= 32;
 	g_arenaservers.pblogo.height				= 16;
-	g_arenaservers.pblogo.errorpic				= ART_UNKNOWNMAP;*/
+	g_arenaservers.pblogo.errorpic				= ART_UNKNOWNMAP;
 	
 	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.banner );
 
@@ -1749,8 +1559,6 @@ static void ArenaServers_MenuInit( void 
 	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.sortkey );
 	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.showfull);
 	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.showempty );
-        Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.onlyhumans );
-        Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.hideprivate );
 
 	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.mappic );
 	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.list );
@@ -1767,8 +1575,8 @@ static void ArenaServers_MenuInit( void 
 	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.create );
 	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.go );
 
-	//Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.punkbuster );
-	//Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.pblogo );
+	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.punkbuster );
+	Menu_AddItem( &g_arenaservers.menu, (void*) &g_arenaservers.pblogo );
 	
 	ArenaServers_LoadFavorites();
 
@@ -1779,7 +1587,7 @@ static void ArenaServers_MenuInit( void 
 		value--;
 	g_arenaservers.master.curvalue = value;
 
-	g_gametype = Com_Clamp( 0, 5, ui_browserGameType.integer );
+	g_gametype = Com_Clamp( 0, 4, ui_browserGameType.integer );
 	g_arenaservers.gametype.curvalue = g_gametype;
 
 	g_sortkey = Com_Clamp( 0, 4, ui_browserSortKey.integer );
@@ -1791,17 +1599,10 @@ static void ArenaServers_MenuInit( void 
 	g_emptyservers = Com_Clamp( 0, 1, ui_browserShowEmpty.integer );
 	g_arenaservers.showempty.curvalue = g_emptyservers;
 	
-        g_arenaservers.onlyhumans.curvalue = Com_Clamp( 0, 1, ui_browserOnlyHumans.integer );
-        g_onlyhumans = ui_browserOnlyHumans.integer;
-        
-        g_arenaservers.hideprivate.curvalue = 1; //Com_Clamp( 0, 1, ui_browserOnlyHumans.integer );
-        g_hideprivate = 1; //ui_browserOnlyHumans.integer;
-	//g_arenaservers.punkbuster.curvalue = Com_Clamp( 0, 1, trap_Cvar_VariableValue( "cl_punkbuster" ) );
+	g_arenaservers.punkbuster.curvalue = Com_Clamp( 0, 1, trap_Cvar_VariableValue( "cl_punkbuster" ) );
 
 	// force to initial state and refresh
-	type = g_servertype;
-	g_servertype = -1;
-	ArenaServers_SetType( type );
+	g_arenaservers.master.curvalue = g_servertype = ArenaServers_SetType(g_servertype);
 
 	trap_Cvar_Register(NULL, "debug_protocol", "", 0 );
 }
@@ -1827,7 +1628,7 @@ void ArenaServers_Cache( void ) {
 	trap_R_RegisterShaderNoMip( ART_ARROWS_UP );
 	trap_R_RegisterShaderNoMip( ART_ARROWS_DOWN );
 	trap_R_RegisterShaderNoMip( ART_UNKNOWNMAP );
-	//trap_R_RegisterShaderNoMip( ART_PUNKBUSTER );
+	trap_R_RegisterShaderNoMip( ART_PUNKBUSTER );
 }
 
 
